# -*- coding: utf-8 -*-
"""
Created on Wed Sep 23 06:55:10 2015

@author: antoine
"""


class PileVideError(Exception):
    pass


class Pile():
    """
    Structure de données de pile

    Appeler Pile() pour créer une pile vide. Les méthodes sont
        - empile
        - depile
        - estvide
        - sommet
    """

    def __init__(self, _init_data=[]):
        self._p = []
        for el in _init_data:
            self.empile(el)

    def estvide(self):
        """
        Teste si cette pile est vide ou non
        """
        return len(self._p) == 0

    def sommet(self):
        """
        Retourne le sommet de cette pile sans dépiler, renvoi une erreur si la pile est vide
        """
        if self.estvide():
            raise PileVideError("La pile est vide !")
        else:
            return self._p[0]

    def empile(self, elt):
        """
        Empile des données dans cette pile

        elt : l'élément à empiler

        Retourne cette pile
        """
        self._p.append(elt)
        return self

    def depile(self):
        """
        Dépile un élément. Renvoie une erreur si la pile est vide
        """
        if self.estvide():
            raise PileVideError("La pile est vide !")
        else:
            return self._p.pop()

    def __str__(self):
        return str(self._p)

    def __repr__(self):
        return "Pile(%s)" % str(self)